【每天学习一点算法 2026/04/17】多数元素

每天学习一点算法 2026/04/17

题目:多数元素

给定一个大小为 n 的数组 nums ,返回其中的多数元素。多数元素是指在数组中出现次数 大于 ⌊ n/2 ⌋ 的元素。

你可以假设数组是非空的,并且给定的数组总是存在多数元素。

最容易想到的方法就是利用 Map 统计各个元素出现的次数,某一个元素超过 n/2 就返回这个元素。

typescript 复制代码
function majorityElement(nums: number[]): number {
  const map: Map<number, number> = new Map()
  for (let i = 0; i < nums.length; i++) {
    const item = nums[i]
    if (map.has(item)) {
      const count = map.get(item)
      map.set(item, count + 1)
      if (count + 1 > nums.length / 2) {
        return item
      }
    } else {
      map.set(item, 1)
      if (nums.length === 1) {
        return item
      }
    }
  }
};

我们还可以对数组进行排序那么位于中间的元素一定是众数

typescript 复制代码
function majorityElement(nums: number[]): number {
  return nums.sort()[Math.floor(nums.length / 2)]
};

**进阶:**尝试设计时间复杂度为 O(n)、空间复杂度为 O(1) 的算法解决此问题。

Boyer-Moore 投票算法

我们遍历数组元素进行两两对比,遇到不同的元素就消耗掉它们,到最后剩下的一定就是众数,因为最差的情况也只能消耗 n / 2 个众。具体实现方法需要维护两个变量,一个是当前候选的众数以及它出现的次数,当次数归零就需要更换候选众数。

typescript 复制代码
function majorityElement(nums: number[]): number {
  let res = nums[0], count = 1 // 初始化候选众数和它出现的次数
  // 遍历消耗元素
  for (let i = 1; i < nums.length; i++) {
    if (nums[i] === res) {
      // 遇到相同元素 数量 + 1
      count++
    } else {
      // 遇到不同元素 数量 - 1
      count--
      if (count === 0) {
        // 如果数量归 0 更换候选众数为下一个元素
        res = nums[i + 1]
      }
    }
    
  }
  return res
};

题目来源:力扣(LeetCode)

相关推荐
实名上网宋凯宣2 分钟前
现代电网可靠性测试系统-VPP工作笔记
笔记·学习
Z21-X8 分钟前
云原生运维学习笔记:KVM实战——从环境搭建到热迁移的硬核体验
运维·笔记·学习·云原生
Cccp.12311 分钟前
【leetcode】(十四)从暴力递归到动态规划
数据结构·算法·leetcode·动态规划
艾莉丝努力练剑13 分钟前
【AI大模型接入SDK】Trae生成代码介绍
网络·c++·人工智能·学习·架构
tellmewhoisi13 分钟前
深度学习5:神经网络学习2:数值微分,偏导,梯度
深度学习·神经网络·学习
辣知16 分钟前
辣知·化智88 为民族示范变革代价与价值
学习
panpan161919 分钟前
中考、高考、KET、PET高效学习工具
学习·高考
旖旎夜光42 分钟前
LeetCode 215: 数组中的第K个最大元素 (快速排序) —— 题解
c++·学习·算法·leetcode·力控
技术胖1 小时前
奎爷巡演 AIGC 视频教程 文档
算法
德彪稳坐倒骑驴1 小时前
Leetcode力扣刷题记录与题解
算法·leetcode·职场和发展